"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.publishAnimation = exports.pullAnimation = void 0;
const node_fetch_1 = require("node-fetch");
const endpoints = require("./endpoints");
async function pullAnimation(id) {
    return (await node_fetch_1.default(endpoints.asset(id)).catch(() => {
        throw new Error(`Cannot pull animation ${id}`);
    })).blob();
}
exports.pullAnimation = pullAnimation;
async function publishAnimation(state, title, description, data, groupId) {
    const response = await node_fetch_1.default(endpoints.publish(title, description, groupId), {
        body: data,
        method: "POST",
        headers: {
            ...state.headers,
            "User-Agent": "RobloxStudio/WinInet",
            Accept: "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8",
        },
    }).catch((e) => {
        throw new Error(`Publish of animation "${title}" failed: ${e.toString()}`);
    });
    if (!response.ok) {
        return Promise.reject(`${title}: ${response.statusText}`);
    }
    return response.text();
}
exports.publishAnimation = publishAnimation;
//# sourceMappingURL=animation.js.map