"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGroupList = exports.getUserList = exports.getList = void 0;
const endpoints = require("./endpoints");
const axios_1 = require("axios");
const cheerio = require("cheerio");
const util_1 = require("./util");
const PER_PAGE = 50;
const LINK_SELECTOR = '.name-col > a';
const HAS_NEXT_PAGE_SELECTOR = '.load-more-items';
async function getList(stream, state, endpoint) {
    for (let pageNum = 0;; pageNum++) {
        const page = await axios_1.default.get(endpoint(pageNum * PER_PAGE), {
            headers: state.headers,
            validateStatus: s => s === 200
        });
        const $ = cheerio.load(page.data);
        $(LINK_SELECTOR).each(function () {
            stream.write(`${util_1.extract(Number, $(this).attr('href'), /catalog\/(\d+)\//, 'Unable to extract animation ID')} ${$(this).text()}\n`);
        });
        if ($(HAS_NEXT_PAGE_SELECTOR).length === 0)
            break;
    }
    stream.end();
}
exports.getList = getList;
async function getUserList(stream, state) {
    return getList(stream, state, s => endpoints.userList(state.userId, s));
}
exports.getUserList = getUserList;
async function getGroupList(stream, state, groupId) {
    return getList(stream, state, s => endpoints.groupList(groupId, s));
}
exports.getGroupList = getGroupList;
//# sourceMappingURL=list.js.map