"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BetterQueue = require("better-queue");
const chalk_1 = require("chalk");
class Queue extends BetterQueue {
    constructor(taskRunner, options) {
        super((data, cb) => {
            taskRunner(data)
                .then((result) => {
                this._size--;
                return cb(null, result);
            })
                .catch((err) => {
                this._size--;
                console.error(chalk_1.default.red(err.toString()));
                return cb(err);
            });
        }, options);
        this._size = 0;
        this.on('task_queued', () => this._size++);
    }
    get size() {
        return this._size;
    }
}
exports.default = Queue;
//# sourceMappingURL=queue.js.map