"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const queue_1 = require("./queue");
const split2 = require("split2");
const animation_1 = require("./animation");
const chalk_1 = require("chalk");
const description = (id) => `Transferred from ID ${id} with roblox-animation-transfer`;
function transfer(inStream, outStream, state, concurrent, groupId) {
    const queue = new queue_1.default(async (d) => (outStream.write((await animation_1.publishAnimation(state, d.title, description(d.id), await animation_1.pullAnimation(d.id), groupId).then(id => `${id} ${d.title}\n`)))), {
        concurrent: concurrent,
        maxRetries: 5,
        retryDelay: 5000,
        maxTimeout: 30000
    });
    inStream
        .pipe(split2())
        .on('data', line => {
        const words = line.split(' ');
        const id = Number(words.shift());
        const title = words.join(' ');
        if (Number.isNaN(id)) {
            console.error(chalk_1.default.red(`Error in input: id for "${title}" is not valid`));
        }
        else {
            queue.push({ id, title });
        }
    });
}
exports.default = transfer;
//# sourceMappingURL=transfer.js.map